﻿// أستدعاء الحزم الإفتراضية
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace sample_project // اسم المشروع ولا بد أن يكون مطابقا لبقية ملفات البرنامج
{
    public partial class replace : Form// الإطار الخاص بالبحث والذي سميناه باسم replace
    {
        private int findStartIndex = 0; // هذا متغير نصي غير عام لمعرفة نقطة البداية عند البحث

        //الإحتفاظ ببيانات مربع التحرير الرئيسي للبرنامج
        private RichTextBox _RichTextBox;

        public replace(RichTextBox txtBox) // حزمة بداية البرنامج الإفتراضية. وبين القوسين قمنا بكتابة الاسم الخاص بمربع التحرير الرئيسي 
        {
            InitializeComponent();// الوضع الإفتراضي
            _RichTextBox = txtBox; // جعلى محتوى مربع التحرير الرئيسي جاهزا للإستخدام
        }

        //حزمة بداية البرنامج الخاصة
        private void replace_Load(object sender, EventArgs e)
        {
find1.Text = Form1.findWhat; // نقوم بإضافة محتوى المتغير findWhat وهوه متغير عام موجود في الإطار form1 نقوم بإضافته لمربع تحرير البحث
            find1.Focus(); // تركيز المؤشر على مربع تحرير البحث
        }

        //حزمة خاصة لاستيراد وتصدير محتوى مربع التحرير الرئيسي
        public RichTextBox RichTextBox
        {
            get { return RichTextBox;} // إستيراد محتوى مربع التحرير الرئيسي
            set { RichTextBox = value; } // تصدير محتوى مربع التحرير الرئيسي إلى إطار الرئيسي
        }

        //حزمة تنفيذ زر إستبدال التالي
        private void okButton_Click(object sender, EventArgs e)
        {
Form1.findWhat = find1.Text; // نقوم بإضافة محتوى مربع التحرير الخاص بالبحث إلى المتغير العام findWhat
replaceFuction(); // إستدعاء الحزمة الخاصة التي أنشأناها لإجراء عملية الإستبدال
        }

// الحزمة الخاصة بإجراء عملية البحث والإستبدال في النصوص
public void replaceFuction()
        {
            string editString = _RichTextBox.Text; // إضافة محتوى مربع التحرير الرئيسي للمتغير editString
            //التعرف على عدد حروف كلمة البحث
            int findStringLength = Form1.findWhat.Length; // نستخدم خاصية length مع المتغير findWhat للتعرف على عدد الحروف وإضافة النتيجة إلى المتغير الرقمي findStringLength
int findPoint = _RichTextBox.SelectionStart; // التعرف على نقطة المؤشر الحالية وذلك باستخدام خاصية SelectionStart وإضافة النتيجة للمتغير الرقمي findPoint
            //أولا يجب علينا البحث عن الكلمات المطلوبة ثم إستبدالها
findPoint = editString.IndexOf(Form1.findWhat, findPoint);// نقوم باستخدام خاصية IndexOf للبحث عن الكلات. وكلمة البحث هي محتوى المتغير findWhat. ومكان البحث هو محتوى مربع التحرير الرئيسي والذي إضفناه إلى المتغير editString . وإذا تم العسور على كلمة البحث نقوم بإضافة نقطة البداية لكلمة البحث إلى المتغير الرقمي findPoint. وفي حالة عدم الحصول على كلمة البحث يكون محتوى المتغير findPoint هو -1. وبهذا إذا كانت قيمة هذا المتغير هي -1 تكون النتيجة غير موجود وإذا كان محتواه 0 أو أكبر من 0 فمعنا هذه أنه قد تم الحصول على كلمة البحث
            //إذا لم نحصل على كلمة البحث المراد إستبدالها
if (findPoint == -1) // إذا كانت قيمة المتغير الرقمي هي -1 
{
// نقوم بكتابة الإجراء المطلوب فعله
MessageBox.Show("لم يتم العسور على كلمة البحث ولم يتم إستبدال أي شيء " + Form1.findWhat + "في المحتوى الحالي");
} else { // وإذا تم الحصول على كلمة البحث المراد إستبدالها
                // // نقوم باختيار الكلمة التي تم الحصول عليها أو بمعنى تركيز المؤشر على هذه الكلمة
_RichTextBox.Select((findPoint + findStringLength), 0); // تستخدم خاصية Select لتثبيت المؤشر على أي نقطة في مربعات التحرير. والمتغير findPoint يعتبر هو نقطة وجود المؤشر وفي هذه الحالة هو أول حرف في كلمة البحث المستخدمة. ولكننا نريد جعل المؤشر في آخر حرف من كلمة البحث قمنا بإضافة عدد حروف كلمة البحث إلى نقطة وجود المؤشر
                // ولإظهار نتيجة أو كلمة البحث التي تم الحصول عليها نقوم بتحريك المؤشر إلى هذه الكلمة
_RichTextBox.ScrollToCaret();// خاصية ScrollToCaret لإنسياب سطور ومحتوى مربعات التحرير متعددة الأسطر
            if (_RichTextBox.SelectionLength > 0) _RichTextBox.SelectedText = find2.Text; // نقوم بإستبدال كلمة الإستبدال الجديدة والموجودة في مربع التحرير الثاني وهو باسم find2. بدلا عن كلمة البحث أو المراد إستبدالها.
                //تركيز المؤشر على عنصر مربع التحرير الرئيسي
_RichTextBox.Focus(); // خاصية Focus هي متخصصة في تركيز المؤشر على عناصر النوافذ المختلفة
}
                        this.Dispose(); // الخروج من هذه النافذة
        }

// تنفيذ حزمة زر إستبدال الكل
        private void okButton2_Click(object sender, EventArgs e)
        {
Form1.findWhat = find1.Text; // نقوم بإضافة محتوى مربع التحرير الخاص بالبحث إلى المتغير العام findWhat
            string editString = _RichTextBox.Text; // إضافة محتوى مربع التحرير الرئيسي للمتغير editString
//إستبدال كافة الكلمات دفعة واحدة
string newData = editString.Replace(Form1.findWhat, find2.Text);// نقوم بإستبدال كافة الكلمات المتاحة دفعة واحدة وذلك باستخدام خاصية replace. وقد قمنا بإضافة المحتوى الجديد الذي تم الإستبدال فيه إلى المتغير newData. 
_RichTextBox.Text = ""; // إفراغ مربع التحرير الرئيسي من المحتوى
_RichTextBox.Text = newData; // إضافة المحتوى الجديد الذي تم إستبداله إلى مربع التحرير الرئيسي
_RichTextBox.Focus(); // تركيز المؤشر على مربع التحرير الرئيسي
_RichTextBox.Modified = true; //ولأننا قمنا بإحداث بعض التغيير في محتوى مربع التحرير الرئيسي يجب علينا جعل خاصية Modified في وضع التفعيل
// حساب عدد الكلمات التي تم إستبدالها وإظهارها في في مربع حوار
int num = Regex.Matches(newData, find2.Text).Count;// تستخدم خاصية Regex.Match لإجراء عمليات البحث المتقدم. نقوم بكتابة اسم هذه الخاصية ومن ثم بين القوسين نقوم بكتابة النص المراد البحث فيه ثم فاصلة ثم كلمة البحث المراد البحث عنها. وأيضا قمنا بإضافة عدد نتيجة البحث إلى المتغير الرقمي الصحيح والذي سميناه باسم num
MessageBox.Show("تم إستبدال " + num.ToString() + " كلمة"); // ولأن مربعات الخيارات لا تستقبل غير المتغيرات النصية قمنا بتغيير المتغير الرقمي إلى متغير نصي وذلك بإضافة خاصية ToString() إلى المتغيرات الرقمية
                        this.Dispose(); // الخروج من هذه النافذة
}

        //حزمة تفنيذ زر الإلغاء
        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Dispose(); // الخروج من هذه النافذة
        }


    }
}