﻿// أستدعاء الحزم الإفتراضية
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace sample_project // اسم المشروع ولا بد أن يكون مطابقا لبقية ملفات البرنامج
{
    public partial class find : Form// الإطار الخاص بالبحث والذي سميناه باسم find
    {
        private int findStartIndex = 0; // هذا متغير نصي غير عام لمعرفة نقطة البداية عند البحث

        //الإحتفاظ ببيانات مربع التحرير الرئيسي للبرنامج
        private RichTextBox _RichTextBox;

        public find(RichTextBox txtBox) // حزمة بداية البرنامج الإفتراضية. وبين القوسين قمنا بكتابة الاسم الخاص بمربع التحرير الرئيسي 
        {
            InitializeComponent();// الوضع الإفتراضي
            _RichTextBox = txtBox; // جعلى محتوى مربع التحرير الرئيسي جاهزا للإستخدام
        }

        //حزمة بداية البرنامج الخاصة
        private void find_Load(object sender, EventArgs e)
        {
if (Form1.findFlag == "findnext") // إذا كان العنصر الذي تم طلبه هو عنصر البحث التالي
{
findFuction(); // نقوم باستدعاء الحزمة الخاصة بالبحث بدون إظهار نافذة البحث
} else { // وإذا كان العنصر الذي تم إختياره هو عنصر البحث
find1.Text = Form1.findWhat; // نقوم بإضافة محتوى المتغير findWhat وهوه متغير عام موجود في الإطار form1 نقوم بإضافته لمربع تحرير البحث
            find1.Focus(); // تركيز المؤشر على مربع تحرير البحث
}
        }

        //حزمة خاصة لاستيراد وتصدير محتوى مربع التحرير الرئيسي
        public RichTextBox RichTextBox
        {
            get { return RichTextBox;} // إستيراد محتوى مربع التحرير الرئيسي
            set { RichTextBox = value; } // تصدير محتوى مربع التحرير الرئيسي إلى إطار الرئيسي
        }

        //حزمة تنفيذ زر البحث
        private void okButton_Click(object sender, EventArgs e)
        {
Form1.findWhat = find1.Text; // نقوم بإضافة محتوى مربع التحرير الخاص بالبحث إلى المتغير العام findWhat
findFuction(); // إستدعاء الحزمة الخاصة التي أنشأناها لإجراء عملية البحث
        }

// الحزمة الخاصة بإجراء عملية البحث في النصوص
public void findFuction()
        {
            string editString = _RichTextBox.Text; // إضافة محتوى مربع التحرير الرئيسي للمتغير editString
            //التعرف على عدد حروف كلمة البحث
            int findStringLength = Form1.findWhat.Length; // نستخدم خاصية length مع المتغير findWhat للتعرف على عدد الحروف وإضافة النتيجة إلى المتغير الرقمي findStringLength
int findPoint = _RichTextBox.SelectionStart; // التعرف على نقطة المؤشر الحالية وذلك باستخدام خاصية SelectionStart وإضافة النتيجة للمتغير الرقمي findPoint
            //البحث عن الكلمات المطلوبة
findPoint = editString.IndexOf(Form1.findWhat, findPoint);// نقوم باستخدام خاصية IndexOf للبحث عن الكلات. وكلمة البحث هي محتوى المتغير findWhat. ومكان البحث هو محتوى مربع التحرير الرئيسي والذي إضفناه إلى المتغير editString . وإذا تم العسور على كلمة البحث نقوم بإضافة نقطة البداية لكلمة البحث إلى المتغير الرقمي findPoint. وفي حالة عدم الحصول على كلمة البحث يكون محتوى المتغير findPoint هو -1. وبهذا إذا كانت قيمة هذا المتغير هي -1 تكون النتيجة غير موجود وإذا كان محتواه 0 أو أكبر من 0 فمعنا هذه أنه قد تم الحصول على كلمة البحث
            //إذا لم نحصل على كلمة البحث
if (findPoint == -1) // إذا كانت قيمة المتغير الرقمي هي -1 
{
// نقوم بكتابة الإجراء المطلوب فعله
MessageBox.Show("لم يتم العسور على كلمة البحث " + Form1.findWhat + "في المحتوى الحالي");
} else { // وإذا تم الحصول على كلمة البحث
                // // نقوم باختيار الكلمة التي تم الحصول عليها أو بمعنى تركيز المؤشر على هذه الكلمة
_RichTextBox.Select((findPoint + findStringLength), 0); // تستخدم خاصية Select لتثبيت المؤشر على أي نقطة في مربعات التحرير. والمتغير findPoint يعتبر هو نقطة وجود المؤشر وفي هذه الحالة هو أول حرف في كلمة البحث المستخدمة. ولكننا نريد جعل المؤشر في آخر حرف من كلمة البحث قمنا بإضافة عدد حروف كلمة البحث إلى نقطة وجود المؤشر
                // ولإظهار نتيجة أو كلمة البحث التي تم الحصول عليها نقوم بتحريك المؤشر إلى هذه الكلمة
_RichTextBox.ScrollToCaret();// خاصية ScrollToCaret لإنسياب سطور ومحتوى مربعات التحرير متعددة الأسطر
                //تركيز المؤشر على عنصر مربع التحرير الرئيسي
_RichTextBox.Focus(); // خاصية Focus هي متخصصة في تركيز المؤشر على عناصر النوافذ المختلفة
}
                        this.Dispose(); // الخروج من هذه النافذة
        }

        //حزمة تفنيذ زر الإلغاء
        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Dispose(); // الخروج من هذه النافذة
        }


    }
}